<script lang="ts">
	import '../../app.css';
	import FooterNav from '../../components/footer/FooterNav.svelte';
	import Header from '../../components/Header.svelte';
	import 'iconify-icon';
	import { onMount } from 'svelte';
	import { scrollY, showMenu, showReturn, store_screenWidth } from '../../utils/store';
	import { auth, db } from '../../lib/firebase/firebase';
	import { getDoc, doc, setDoc } from 'firebase/firestore';
	import { authStore } from '../../store/store';
	import Button from '../../components/Button.svelte';

	let y = 0;

	onMount(() => {
		const handleScroll = () => {
			y = window.scrollY;
		};

		window.addEventListener('scroll', handleScroll);

		return () => {
			window.removeEventListener('scroll', handleScroll);
		};
	});

	let screenWidth: number = 0;
	$: if (y) {
		scrollY.update((_) => y);
	}

	$: if (screenWidth) {
		store_screenWidth.update((_) => screenWidth);
	}

	let headerHeight: number;

	const nonAuthRoutes = ['/', '/metrouver', '/fournisseurs', '/produit', '/admin'];
	let asLoaded: boolean = false;
	let isConnected: boolean = false;
	onMount(() => {
		asLoaded = true;

		const unsubscribe = auth.onAuthStateChanged(async (user) => {
			const currentPath = window.location.pathname;

			if (!user && !nonAuthRoutes.includes(currentPath)) {
				window.location.href = '/';
				return;
			}

			if (user && currentPath === '/admin') {
				window.location.href = '/admin/dashboard';
				return;
			}
			if (!user) {
				return;
			}
			isConnected = true;
		});
		return unsubscribe;
	});

	$showMenu = false;
</script>

<svelte:window bind:innerWidth={screenWidth} />

<div
	class="relative flex flex-col w-screen h-screen scroll-container"
	style={'width:' + screenWidth + 'px; '}
>
	<div class="w-full p-4 text-2xl flex justify-around" bind:clientHeight={headerHeight}>
		<span class="font-title text-3xl font-semibold grow">
			<a class="cursor-pointer text-white" href={isConnected ? '/admin/dashboard' : '/admin'}
				>Madame Pain - admin</a
			>
		</span>
		{#if isConnected}
			<Button type="secondary" on:click={() => auth.signOut()}>Se déconnecter</Button>
		{/if}
	</div>
	<div class="relative grow md:mb-0 mb-14 text-white">
		<slot />
	</div>
</div>
